<?php
/******************************************************************************
quota.php written by Damian oziski (nonick@o2.pl)
modified files: 
admin.php, config.php, functions.php, index.php, login.php [locking user], 
*******************************************************************************/
include_once("config.php");
include_once("functions.php");
Include_once("AliasFile.php");

function checkQuota($torrent)
{   
    global $cfg;
    global $messages;
    
    $torrent = urldecode($torrent);
    $owner = getOwner($torrent);
    $alias = getAliasName($torrent);
    $af = new AliasFile($cfg["torrent_file_path"].$alias.".stat", $owner);

    $used = (int) shell_exec("du -smL ".$cfg["path"].$owner."|cut -f1");
    $db = getdb();
    loadSettings();

    $sql = "SELECT * FROM tf_quota WHERE user=".$db->qstr($owner);
    $rs = $db->Execute($sql);
    showError($db,$sql);
    
    $row = $rs->FetchRow();
    $quota = (int) $row['quota'];
    $using = (int) $row['using_space'];
     
    if ($af->percent_done < 0) $new = ((int) ((200 + $af->percent_done)/100 * $af->size)) >> 20;
    else if ($af->percent_done == 100) $new = 0;
         else $new = $af->size >> 20;
   /* 
    $messages .= "done: {$af->percent_done}, new: $new <br />";
    $messages .= "chwilowo nie mozna startowac nowych torrentow. sorry <br />";
    return false;
   */
    
    // if home is empty you can download a little more 
    // or if quota is set to 0 you can download unlimited torrents
    if (!$quota || ( $using == 0 && $used <= 1 && $new < (int)($cfg["factor"]*$quota) )) 
        return true;
    
    // otherwise checking normal quota
    if ($used + $using + $new < $quota) return true;
    else
	    {
                
                $messages .= "<strong>QUOTA: </strong>new/last: $new MB, reserved for running: $using MB, used diskspace: $used MB,<br />total used: ".($using+$used)." MB. ";
                $messages .= "You have not enough diskspace to start this torrent. Your limit is $quota MB.<br />";
                $messages .= "You can download up to ".($cfg["factor"]*$quota)."MB if tided your dir first<br />";
		return false;   
	    }

}
?>
